#include <stdio.h> 
#include <stdlib.h> 
#include "Pile.h"

/***********************************************************************
 * @brief : test si une pile est vide. 
 * @return :  1 si vide 0 sinon
 * */
int estPileVide(TCellule *p) 
{ 
	return (!p) ;
}

/***********************************************************************
 * @brief : crée une nouvelle Pile
 * @return :  une pile vide.
 * */
TCellule *newPile() { 
	return NULL ; 
}

/***********************************************************************
 * @brief : crée une cellule
 * @return :  pointeur sur la cellule créée
 * @param : le nb à stocker dans la cellule
 * */
TCellule *newCellule (double nb) 
{
	TCellule *pc ;
	pc = (TCellule*) malloc (sizeof(TCellule)) ;
	pc-> nb = nb;
	pc->suiv = NULL ;
	return (pc) ;
}

/***********************************************************************
 * @brief : insère en tête un nombre dans la pile
 * @return :  pointeur sur la pile
 * @param : le pointeur de la tête de la pile
 * @param : le nb à stocker dans la pile
 * */
TCellule * insererPile (TCellule *p, double nb) 
{
	TCellule *nc ;
	nc = newCellule(nb);
	if (estPileVide(p) ) {return(nc) ; }
	nc->suiv = p ; 
	return nc ;
}

/***********************************************************************
 * @brief : affiche la pile
 * @return :  rien
 * @param : le pointeur de la tête de la pile
 * */
void afficherPile (TCellule *pile) 
{
	TCellule *p = pile ;
	
	printf ("Pile : ") ; 
	if (estPileVide(p)) { 
		printf("Pile vide\n") ; 
		return ;
	}
	do {
		printf ("%lf ", p->nb) ;
		p=p-> suiv ;
	}
	while(p!=NULL) ;
	printf ("\n") ; 

}
